package myalgorithms.sorting;

import java.util.Arrays;

public class Sorter {
	
	public void insertionSort(int[] array) {
		for (int j = 1; j < array.length; j++) {
			int key = array[j];
			int i = j - 1;
			while (i >= 0 && array[i] > key) {
				array[i+1] = array[i];
				i--;
			}
			array[i+1] = key;
		}
	}
	
	public static void mergesort(int[] a, int p, int r) {
		if (p < r) {
			int q = (p+r)/2;
			mergesort(a, p, q);
			mergesort(a, q+1, r);
			merge(a, p, q, r);
		}
	}
	
	private static void merge(int[] a, int p, int q, int r) {
		int n1 = q-p+1;
		int n2 = r-q;
		
		int[] left = new int[n1+1];
		int[] right = new int[n2+1];
		
		for (int i = 0; i < n1; i++) {
			left[i] = a[p+i];
		}
		
		for (int i = 0; i < n2; i++) {
			right[i] = a[q+i+1];
		}
		
		left[n1] = Integer.MAX_VALUE;
		right[n2] = Integer.MAX_VALUE;
		
		int i = 0;
		int j = 0;
		
		for (int k = p; k <= r; k++) {
			if (left[i] <= right[j]) {
				a[k] = left[i];
				i++;
			} else {
				a[k] = right[j];
				j++;
			}
		}
	}
	
	public static void quicksort(int[] a, int p, int r) {
		if (p < r) {
			int q = partition(a, p, r);
			quicksort(a, p, q - 1);
			quicksort(a, q + 1, r);
		}
	}
	
	private static int partition(int[] a, int p, int r) {
		int pivot = a[r];
		int i = p - 1;
		
		for (int j = p; j <= r - 1; j++) {
			if (a[j] <= pivot) {
				i++;
				swap(a, i, j);
			}
		}
		swap(a, i + 1, r);
		
		return i + 1;
	}
	
	private static void swap(int[] a, int i, int j) {
		if (i >= 0 && j >= 0 && i <= a.length && j <= a.length) {
			int aux = a[i];
			a[i] = a[j];
			a[j] = aux;			
		}
	}
	
	public static void main(String[] args) {
		int[] a = new int[] {5, 2, 4, 6, 1, 3};
		
		quicksort(a, 0, 5);
		
		System.out.println(Arrays.toString(a));
	}

}
