/*
 * my_list.cpp
 *
 *  Created on: Mar 19, 2013
 *      Author: promulo
 */

#include "../headers/my_list.h"

MyList::MyList() : m_head(NULL), m_tail(NULL), m_size(0)
{
}

MyList::~MyList()
{
}

void MyList::add(int element)
{
	ListNode* newNode = new ListNode;
	newNode->prev = newNode->next = NULL;
	newNode->value = element;

	if (empty()) {
		m_head = newNode;
		m_tail = newNode;
	} else {
		m_tail->next = newNode;
		newNode->prev = m_tail;
		m_tail = newNode;
	}

	++m_size;
}

void MyList::remove(int element)
{
	if (empty()) {
		return;
	}

	int index = indexOf(element);
	if (index != -1) {
		removeFrom(index);
	}
}

void MyList::removeFrom(int index)
{
	if (empty() || index > m_size - 1 || index < 0) {
		return;
	}

	int count = 0;
	ListNode* node = m_head;
	while (count != index) {
		node = node->next;
		++count;
	}

	if (node->prev != NULL) {
		node->prev->next = node->next;
	} else {
		m_head = node->next;
	}

	if (node->next != NULL) {
		node->next->prev = node->prev;
	} else {
		m_tail = node->prev;
		node->prev->next = NULL;
	}

	--m_size;

	delete node;
	node = NULL;
}

int MyList::indexOf(int element)
{
	int index = 0;
	ListNode* node = m_head;
	while (node != NULL) {
		if (node->value == element) {
			return index;
		} else {
			++index;
			node = node->next;
		}
	}

	return -1;
}



