package mydatastructures.datastructures;

public class BinaryTree {
	
	TreeNode root;
	
	public void insert(int key)	{
		TreeNode z = new TreeNode(key);
		
		TreeNode y = null;
		TreeNode x = root;
		
		while (x != null) {
			y = x;
			if (z.key <= x.key) {
				x = x.left;
			} else {
				x = x.right;
			}
		}
		
		z.parent = y;
		
		if (y == null) {
			root = z;
		} else {
			if (z.key <= y.key) {
				y.left = z;
			} else {
				y.right = z;
			}
		}
	}
	
	public void printInOrder() {
		inOrder(root);
	}
	
	private void inOrder(TreeNode root) {
		if (root != null) {
			inOrder(root.left);
			System.out.println(root.key);
			inOrder(root.right);
		}
	}
	
	public TreeNode search(int k) {
		return doSearch(root, k);
	}
	
	private TreeNode doSearch(TreeNode root, int k) {
		if (root == null || root.key == k) {
			return root;
		}
		
		if (k < root.key) {
			return doSearch(root.left, k);
		} else {
			return doSearch(root.right, k);
		}
	}
	
	public int getMinimum() {
		if (root != null) {			
			TreeNode x = root;
			while (x.left != null) {
				x = x.left;
			}
			
			return x.key;
		}
		
		return -1;
	}
	
	public int getMaximum() {
		if (root != null) {
			TreeNode x = root;
			while (x.right != null) {
				x = x.right;
			}
			
			return x.key;
		}
		
		return -1; 
	}

}

class TreeNode {
	TreeNode left;
	
	int key;
	
	TreeNode right;
	
	TreeNode parent;
	
	public TreeNode(int key) {
		this.key = key;
	}
}
