package mydatastructures.datastructures;

import java.util.Arrays;


public class HashTable {
	
	private LinkedListWithObjects[] table;
	
	private final int PRIME = 701;
	
	public HashTable() {
		table = new LinkedListWithObjects[PRIME];
		Arrays.fill(table, null);
	}
	
	private int getHash(int k) {
		return k % PRIME;
	}
	
	public void insert(char element) {
		int position = getHash(Character.toLowerCase(element));
		if (table[position] == null) {
			table[position] = new LinkedListWithObjects();
		}
		
		table[position].insert(element);
	}
	
	public boolean containsValue(char element) {
		int position = getHash(Character.toLowerCase(element));
		
		return table[position] == null ? null : table[position].search(element) != null;
	}
	
	public void delete(char element) {
		int position = getHash(Character.toLowerCase(element));
		
		if (table[position] != null) {
			table[position].delete(element);			
		}
	}

}
