package mydatastructures.datastructures;

public class LinkedListWithObjects {
	
	private Node head;
	
	public Node search(Object key) {
		Node x = head;
		while (x != null && !x.getKey().equals(key)) {
			x = x.getNext();
		}
		
		return x;
	}
	
	public void insert(Object x) {
		Node newNode = new Node(x);
		newNode.setNext(head);
		if (head != null) {
			head.setPrev(newNode);
		}
		head = newNode;
		newNode.setPrev(null);
	}
	
	public void delete(Object x) {
		Node toDelete = search(x);
		if (toDelete != null) {
			if (toDelete.getPrev() != null) {
				toDelete.getPrev().setNext(toDelete.getNext());
			} else {
				head = toDelete.getNext();
			}
			
			if (toDelete.getNext() != null) {
				toDelete.getNext().setPrev(toDelete.getPrev());
			}
			
			toDelete.setNext(null);
			toDelete.setPrev(null);
		}
	}
	
	public boolean isEmpty() {
		return head == null;
	}
	
	public Node getHead() {
		return head;
	}
	
	public void setHead(Node head) {
		this.head = head;
	}

}

class Node {
	private Node prev;
	
	private Object key;
	
	private Node next;
	
	public Node(Object key) {
		this.key = key;
	}
	
	public Object getKey() {
		return key;
	}
	
	public Node getPrev() {
		return prev;
	}
	
	public void setPrev(Node prev) {
		this.prev = prev;
	}
	
	public Node getNext() {
		return next;
	}
	
	public void setNext(Node next) {
		this.next = next;
	}
}
