package mydatastructures.datastructures;

import static org.junit.Assert.*;

import org.junit.Test;

public class LinkedListTest {

	@Test
	public void testLinkedListWithObjects() {
		LinkedListWithObjects list = new LinkedListWithObjects();
		assertTrue(list.isEmpty());
		
		list.insert(1);
		assertFalse(list.isEmpty());
		
		assertEquals(1, list.getHead().getKey());
		
		assertNull(list.getHead().getPrev());
		assertNull(list.getHead().getNext());
		
		Node node = list.search(1);
		assertNotNull(node);
		assertEquals(1, node.getKey());
		
		list.insert(2);
		list.insert(3);
		
		node = list.search(2);
		assertNotNull(node);
		assertEquals(2, node.getKey());
		assertEquals(3, node.getPrev().getKey());
		assertEquals(1, node.getNext().getKey());
		
		list.delete(2);
		
		node = list.search(2);
		assertNull(node);
		
		assertEquals(3, list.getHead().getKey());
		assertEquals(1, list.getHead().getNext().getKey());
		
		list.insert(4);
		list.insert(5);
		
		assertEquals(5, list.getHead().getKey());
		
		list.delete(5);
		assertEquals(4, list.getHead().getKey());
		
		assertNotNull(list.search(1));
		list.delete(1);
		assertNull(list.search(1));
	}
	
	@Test
	public void testLinkedListWithArrays() throws Exception {
		LinkedListWithArrays list = new LinkedListWithArrays(10);
		assertTrue(list.isEmpty());
		
		list.insert(1);
		assertFalse(list.isEmpty());
		
		assertEquals(1, list.getHead());
		
		assertEquals(-1, list.getNext(1));
		assertEquals(-1, list.getPrev(1));
		
		list.insert(2);
		list.insert(3);
		
		assertEquals(-1, list.getPrev(3));
		assertEquals(2, list.getNext(3));
		
		assertEquals(3, list.getPrev(2));
		assertEquals(1, list.getNext(2));
		
		assertEquals(2, list.getPrev(1));
		assertEquals(-1, list.getNext(1));
		
		list.delete(2);
		
		assertEquals(3, list.getHead());
		assertEquals(1, list.getNext(3));
		
		assertEquals(3, list.getPrev(1));
		assertEquals(-1, list.getNext(1));
		
		list.insert(4);
		list.insert(5);
		
		assertEquals(5, list.getHead());
		
		list.delete(5);
		assertEquals(4, list.getHead());
	}

}
