package mygraphs.algorithms;

import static mygraphs.repr.Vertix.Color.BLACK;
import static mygraphs.repr.Vertix.Color.GRAY;
import static mygraphs.repr.Vertix.Color.WHITE;

import java.util.LinkedList;
import java.util.Queue;

import mygraphs.repr.Graph;
import mygraphs.repr.Vertix;

public class BFS {
	
	public void bfs(Graph graph, int source) {
		Vertix root = graph.getVertix(source);
		root.setColor(GRAY);
		root.setDistance(0);
		root.setParent(null);
		
		Queue<Vertix> queue = new LinkedList<Vertix>();
		
		queue.add(root);
		
		while (!queue.isEmpty()) {
			Vertix u = queue.remove();
			for (Vertix v : graph.getAdjacencyLists().get(u)) {
				if (WHITE.equals(v.getColor())) {
					v.setColor(GRAY);
					v.setDistance(u.getDistance() + 1);
					v.setParent(u);
					queue.add(v);
				}
			}
			u.setColor(BLACK);
		}
	}

}
