package mygraphs.algorithms;

import static mygraphs.repr.Vertix.Color.BLACK;
import static mygraphs.repr.Vertix.Color.GRAY;
import static mygraphs.repr.Vertix.Color.WHITE;
import mygraphs.repr.Graph;
import mygraphs.repr.Vertix;

public class DFS {
	
	private static int time = 0;
	
	public void dfs(Graph graph) {
		for (Vertix u : graph.getAdjacencyLists().keySet()) {
			if (WHITE.equals(u.getColor())) {
				dfsVisit(u, graph);
			}
		}		
	}
	
	private void dfsVisit(Vertix u, Graph g) {
		u.setColor(GRAY);
		u.setDistance(++time);
		for (Vertix v : g.getAdjacencyLists().get(u)) {
			if (WHITE.equals(v.getColor())) {
				v.setParent(u);
				dfsVisit(v, g);
			}
		}
		u.setColor(BLACK);
		u.setFinish(++time);
	}

}
