package mygraphs.repr;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

public class Graph {
	
	private byte[][] adjacencyMatrix;
	
	private Map<Vertix, List<Vertix>> adjacencyLists;
	
	public Graph(byte[][] adjacencyMatrix) {
		this.adjacencyMatrix = adjacencyMatrix;
		parseAdjacencyMatrix();
	}
	
	private void parseAdjacencyMatrix() {
		this.adjacencyLists = new TreeMap<Vertix, List<Vertix>>();
		for (int i = 0; i < adjacencyMatrix.length; i++) {
			Vertix key = getVertix(i);
			for (int j = 0; j < adjacencyMatrix[i].length; j++) {
				if (adjacencyMatrix[i][j] == 1) {
					adjacencyLists.get(key).add(getVertix(j));
				}
			}
		}
	}
	
	public Map<Vertix, List<Vertix>> getAdjacencyLists() {
		return adjacencyLists;
	}
	
	public Vertix getVertix(int label) {
		for (Vertix v : adjacencyLists.keySet()) {
			if (v.getLabel() == label) {
				return v;
			}
		}
		
		Vertix key = new Vertix(label);
		adjacencyLists.put(key, new ArrayList<Vertix>());
		
		return key;
	}

}
