package mygraphs.repr;

public class Vertix implements Comparable<Vertix> {
	
	public enum Color {
		WHITE, GRAY, BLACK
	}
	
	private int label;
	
	private Color vColor;
	
	private int distance;
	
	private int finish;
	
	private Vertix parent;
	
	public Vertix(int label){
		setLabel(label);
		setColor(Color.WHITE);
		setDistance(0);
		setParent(null);
	}
	
	public int getLabel() {
		return label;
	}
	
	public void setLabel(int label) {
		this.label = label;
	}

	public Color getColor() {
		return vColor;
	}

	public void setColor(Color color) {
		this.vColor = color;
	}

	public int getDistance() {
		return distance;
	}

	public void setDistance(int distance) {
		this.distance = distance;
	}

	public Vertix getParent() {
		return parent;
	}

	public void setParent(Vertix parent) {
		this.parent = parent;
	}
	
	public int getFinish() {
		return finish;
	}

	public void setFinish(int finish) {
		this.finish = finish;
	}

	@Override
	public boolean equals(Object vertix) {
		if (vertix instanceof Vertix) {
			Vertix other = (Vertix) vertix;
			return this.getLabel() == other.getLabel();
		}
		
		return false;
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("[");
		sb.append(getLabel());
		sb.append(", ");
		sb.append(getColor());
		sb.append(", ");
		sb.append(getDistance());
		sb.append("]");
		
		return sb.toString();
	}

	@Override
	public int compareTo(Vertix arg0) {
		return this.getLabel() - arg0.getLabel();
	}
	
}